'gbburn5331.vbs
'
' 5511 mod to scan all video directories at once.  Debug is =5511
' 5511 mod fix reburn same disk

Option Explicit

'dims
Dim WshShell, Copy2DVD, oArgs, fso,f, i, j, k, fsOut, datestamp, fc, file, numfiles, fsDVD
Dim burnerdriveletter
Dim logfile, lastdvdfile
Dim lastdvdnumber
Dim dvdbytelimit
Dim Copy2DVDpath
Dim WriteFlag
Dim burndir, burninifile, batchlogdir
Dim burnfile, burntext, burnfileroot
Dim nextsmall, search, msgboxret, msgtxt
Dim MovieLibLog, xmlDoc, x, MovieLogText, xmlloaded, xmlRefID, xmlRefDate, xmlFormat
Dim VideoDirs, BurnOK

'=5511 eliminate videodir arg
'=== Get the command line arguments
Set WshShell = CreateObject( "Wscript.Shell" ) 
Set oArgs = Wscript.Arguments
If oArgs.Count = 0 Then
	Wscript.Echo "USAGE: gbburn fullinipath"
	Wscript.Echo ""
	Wscript.Quit 1
End If

' make sure ini file exists
Set fso = CreateObject("Scripting.FileSystemObject")
If Not fso.FileExists(oArgs(0)) Then
	Wscript.Echo oArgs(0) & "is not a valid INI File"
	Wscript.Quit 1
End If

'burndir = oArgs(0)
burninifile = oArgs(0)

' Set Variables from INI
lastdvdnumber = GetINIString("General", "lastdvdnumber", 1001, burninifile)
burnerdriveletter=GetINIString("General", "burnerdriveletter", "driveletter", burninifile)
logfile=GetINIString("General", "logfile", "logfile", burninifile)
dvdbytelimit=GetINIString("General", "dvdbytelimit", 18, burninifile)
burnfileroot=GetINIString("General", "burnfileroot", "burnbatch", burninifile)
dvdbytelimit=dvdbytelimit+0
Copy2DVDpath=GetINIString("General", "Copy2DVDpath", "", burninifile)
batchlogdir=GetINIString("General", "batchlogdir", "", burninifile)
MovieLibLog=GetINIString("General", "MovieLibLog", "", burninifile)
WriteFlag=GetINIString("General", "WriteFlag", "", burninifile)
VideoDirs=GetINIString("General", "VideoDirs", "", burninifile)

' If a directory is specified, just burn that 
If oArgs.Count = 2 Then
VideoDirs = oArgs(1)
End If

'=5511 never used the log file
' Get logfile object ready for appending
'If WriteFlag Then
'	Set fsOut = fso.OpenTextFile(logfile, ForAppending, True)
'	datestamp = Date & " " & Time
'End If

' Prompt for dry run
Dim dryrun
msgtxt = "Do you want a dry run?" & vbCrLf & vbCrLf
msgtxt = msgtxt & "Yes - Display batches and exit" & vbCrLf & vbCrLf
msgtxt = msgtxt & "No  - Place a blank DVD in the tray" & vbCrLf
msgtxt = msgtxt &  vbCrLf
msgboxret = MsgBox (msgtxt, 68, "DVD Burn Status")
Select Case msgboxret
	Case vbYes
		Wscript.Echo "Proceed with Dry Run"
		dryrun = True
	Case vbNo
		Wscript.Echo "Proceed normally"
		dryrun = False
	Case vbCancel
		Wscript.Echo "gbBurn canceled"
		Wscript.Quit 0
End Select

'Set up arrays
' Valid xml and mpg files in the directory
Dim aFiles(300,300)
Dim aFilesName, aFilesSize, aFilesWritten, aFilesMname, aFilesBatchNum, aBurnNumBatchFiles
aFilesName = 1
aFilesSize = 2
aFilesWritten = 3
aFilesMname = 4
aFilesBatchNum = 5

' Batch info
Dim aBurn(50,50)
Dim aBurnBatchName, aBurnBatchNum, aBurnDVDNum, aBurnBatchText, aBurnBatchSize
Dim batchnum, lastbatch
batchnum = 1
aBurnBatchName = 1
aBurnBatchNum = 2
aBurnDVDNum = 3
aBurnNumBatchFiles = 4
aBurnBatchText = 5
aBurnBatchSize = 6

'=5511 add VideoDirs array
Dim aVideoDirs, CurrentDir, NumDirs
aVideoDirs = Split(VideoDirs, ",", -1, 1)
NumDirs = UBound(aVideoDirs,1)

'Wscript.Echo "dir1=" & aVideoDirs(1)
'Wscript.Echo "dir2=" & aVideoDirs(2)
'Wscript.Echo "dir0=" & aVideoDirs(0)

' Constant Required for OpenTextFile function
Const ForReading = 1
Const ForWriting = 2
Const ForAppending = 8
 
'main

' Set counter
i=0
		
' Load the arrays
Dim mpgfile, xmlfile, mpgfilesize, fso1, f1
j = 0

For j = 0 to NumDirs
	' Get the file set
	
'Wscript.Echo "dir " & j & "=" & aVideoDirs(j) &"|"
'Wscript.Echo "NumDirs=" & NumDirs

	Set fso = CreateObject("Scripting.FileSystemObject")
	Set f = fso.GetFolder(aVideoDirs(j))
	Set fc = f.Files

	For each file in fc
		' Wscript.Echo "file " & file & " size=" & file.size/1000
		search = instr(file.Name, ".xml" )   ' Pick up all xml files. 
					        
		If ( search > 0 ) Then
			mpgfile = Left(file.Path,Len(file.Path) - 4) & ".mpg"
			' Wscript.Echo "mpgfile " & mpgfile
	
			If fso.FileExists(mpgfile) Then
				Set f1 = fso.GetFile(mpgfile)
				mpgfilesize = f1.size/1000
	
				' Wscript.Echo "mpgfile " & mpgfile & " - Size=" & mpgfilesize & " limit=" & dvdbytelimit
				' Wscript.Echo "xmlfile " & file
				If mpgfilesize < dvdbytelimit Then
					aFiles(i,aFilesName) = file
					aFiles(i,aFilesSize) = f1.Size/1000
					aFiles(i,aFilesWritten) = 0
					aFiles(i,aFilesMname) = mpgfile
					i=i+1
				End If
			End If
	    	End If 
		'debug
		'Wscript.Echo "file " & i & " " & aFiles(i,aFilesSize) & " == " & file.Name
	Next
Next
numfiles = i

'
' Wscript.Quit 0

'sort the array descending file size
QuickSort aFiles, 0, numfiles, aFilesSize, "DESC"
'sort is returning an extra empty record
numfiles = numfiles-1
nextsmall = numfiles

' Zero the batch variables
Dim batchsize, burnfilename, fsBurnFile
batchsize = 0
burntext = ""
i=0
j=0

' Walk the files creating batches less than max size
Do Until i > nextsmall
	' Wscript.Echo "File " & i & " == " & aFiles(i,aFilesName)  & " batch=" & batchnum
	If aFiles(i,aFilesSize) < (dvdbytelimit-batchsize) And aFiles(i,aFilesWritten) = 0 And nextsmall > i Then
	' if the file will fit into the batch, save the record
		batchsize = batchsize + aFiles(i,aFilesSize)
		burntext = burntext & aFiles(i,aFilesName) & VbCrLf
		burntext = burntext & aFiles(i,aFilesMname) & VbCrLf
		aFiles(i,aFilesWritten) = 1
		aFiles(i,aFilesBatchNum) = batchnum
		j=j+1
		i=i+1
	Else
		Do Until nextsmall <= i
		' Attempt to add small files from the bottom up to fill the batch

			If aFiles(nextsmall,aFilesSize) < (dvdbytelimit-batchsize) And aFiles(nextsmall,aFilesWritten) = 0 Then
				batchsize = batchsize + aFiles(nextsmall,aFilesSize)
				burntext = burntext & aFiles(nextsmall,aFilesName) & VbCrLf
				burntext = burntext & aFiles(nextsmall,aFilesMname) & VbCrLf
				aFiles(nextsmall,aFilesWritten) = 1
				aFiles(nextsmall,aFilesBatchNum) = batchnum
				' Wscript.Echo "Add small file " & nextsmall & " " & aFiles(nextsmall,aFilesName)
				j=j+1
				nextsmall = nextsmall - 1
			Else
				Exit Do
			End If
		Loop

		' this batch is full so write it to the batch array
		lastdvdnumber = lastdvdnumber + 1
		burnfilename = batchlogdir & burnfileroot & lastdvdnumber & ".txt"
		aBurn(batchnum,aBurnBatchNum) = batchnum
		aBurn(batchnum,aBurnBatchName) = burnfilename		
		aBurn(batchnum,aBurnDVDNum ) = lastdvdnumber
		aBurn(batchnum,aBurnNumBatchFiles) = j
		aBurn(batchnum,aBurnBatchText) = burntext
		aBurn(batchnum,aBurnBatchSize) = batchsize
		' Wscript.Echo burnfile & lastdvdnumber & " Saved. Batchnum=" & batchnum
		lastbatch = batchnum

		' the current file starts the new batch
		batchnum = batchnum + 1
		burntext = aFiles(i,aFilesName) & VbCrLf
		burntext = burntext & aFiles(i,aFilesMname) & VbCrLf
		batchsize = aFiles(i,aFilesSize)
		aFiles(i,aFilesWritten) = 1
		aFiles(i,aFilesBatchNum) = batchnum
		' Wscript.Echo "Start Batch " & batchnum & " " & aFiles(i,aFilesName)
		j=1
		i=i+1
	End If
Loop

' The last batch is partial and picked up on the next run
lastbatch = lastbatch - 1

' batches ready to call copy2dvd, move completed files to DONE, save last dvd number written
Dim cmdstr, thisfile
For i=1 to lastbatch
	' Wscript.Echo "Processing " & aBurn(i,aBurnBatchName) & " == " & aBurn(i,aBurnBatchNum)
	Wscript.Echo "======= Begin Writing DVD Number " & aBurn(i,aBurnDVDNum) & " ============ "
	cmdstr = Copy2DVDPath & " /writedevice=" & Chr(34) & burnerdriveletter & Chr(34) & " /datafl=" & Chr(34) & aBurn(i,aBurnBatchName) & Chr(34)
	If Not dryrun Then
		burntext = ";Total=" & aBurn(i,aBurnNumBatchFiles) & " files. " & aBurn(i,aBurnBatchSize) & "K on " & datestamp & VbCrLf & ";DVD Number =" & aBurn(i,aBurnDVDNum) & " - " & aBurn(i,aBurnBatchName) & VbCrLf & aBurn(i,aBurnBatchText)
		If WriteFlag Then
			Set fsBurnFile = fso.OpenTextFile(aBurn(i,aBurnBatchName), ForWriting, True)
			fsBurnFile.Write burntext
			fsBurnFile.Close
			RunCMD(cmdstr)
		End If

		' rewrite dialog

		BurnOK = False
		Do While Not dryrun And Not BurnOK
			msgtxt = "DVD Number " & aBurn(i,aBurnDVDNum) & " Attempted Burn OK?" & VbCrLf
			If i <> lastbatch Then
				msgtxt = msgtxt & "Yes    - Burn OK - Write Number on DVD, Load blank DVD and Continue"  & VbCrLf
			Else
				msgtxt = msgtxt & "Yes    - Burn OK - Write Number on DVD and close tray.  WE ARE DONE."  & VbCrLf		
			End If
			msgtxt = msgtxt & "No     - Burn This Batch Again"  & VbCrLf
			msgtxt = msgtxt & "Cancel - Stop this run now"
			msgboxret = MsgBox (msgtxt, 35, "DVD Burn Status")
			Select Case msgboxret
				Case vbNo
					Wscript.Echo "=AGAIN= Begin Writing DVD Number " & aBurn(i,aBurnDVDNum) & " ===AGAIN===== "
					If Not dryrun Then
						If WriteFlag Then
							RunCMD(cmdstr)
						End If
					Else
						Wscript.Echo "Dry Run - Total=" & aBurn(i,aBurnNumBatchFiles) & " files. " & aBurn(i,aBurnBatchSize) & "K on " & datestamp & VbCrLf & ";DVD Number =" & aBurn(i,aBurnDVDNum) & " - " & aBurn(i,aBurnBatchName) & VbCrLf & aBurn(i,aBurnBatchText)
					End If
				Case vbYes
					BurnOK = True
					If WriteFlag Then
						WriteINIString "General", "lastdvdnumber", aBurn(i,aBurnDVDNum), oArgs(0)
						Wscript.Echo "DVD Number " & aBurn(i,aBurnDVDNum) & " Saved"
					End If
				Case Else
					Wscript.Echo "Process Canceled"
					Wscript.Quit 0				
			End Select
						
		Loop
	
	Else
		Wscript.Echo "Dry Run - Total=" & aBurn(i,aBurnNumBatchFiles) & " files. " & aBurn(i,aBurnBatchSize) & "K on " & datestamp & VbCrLf & ";DVD Number =" & aBurn(i,aBurnDVDNum) & " - " & aBurn(i,aBurnBatchName) & VbCrLf & aBurn(i,aBurnBatchText)
	End If
	' move xml file to batchlogdir
	j=0
	For j = 0 to numfiles
		'Wscript.Echo "move=" & aFiles(j,aFilesName) & " batchnum=" & aFiles(j,aFilesBatchNum)
		If aFiles(j,aFilesBatchNum) = i Then
			Set thisfile = fso.GetFile(aFiles(j,aFilesName))
			If Not dryrun Then
				' convert xml and append to log
				' Movie Library tab delimited format is:
				' MovieLib Field	Sage EPG Field
				' ReferenceID		DVD Number
				' Title			EPG Title
				' Comment		All Other EPG fields delimited by line feeds
				'
				' Wscript.Echo "loading=" &  aFiles(j,aFilesName)
				Set xmlDoc=CreateObject("Microsoft.XMLDOM")
				xmlDoc.async=true
				xmlloaded = xmlDoc.load(aFiles(j,aFilesName))
				xmlRefID = aBurn(i,aBurnDVDNum)
				xmlRefDate = Date
				xmlFormat = "mpgX"
				MovieLogText = xmlRefId
				Wscript.Echo "xmlloaded=" & xmlloaded & "  xmlfile=" & aFiles(j,aFilesName)
				If xmlloaded Then
					For Each x in xmlDoc.documentElement.childNodes
						If x.nodename = "Title" Then
							MovieLogText = MovieLogText & vbTab & x.text & vbTab 
						Else
							MovieLogText = MovieLogText & vbLf & x.nodename & ": " & x.text
						End If
					' Wscript.Echo "field=" & x.text & "||"
					Next
				Else
					Wscript.Echo "fail=" & xmlloaded & "  xmlfile=" & aFiles(j,aFilesName)
					MovieLogText = MovieLogText & vbTab & aFiles(j,aFilesName) & "-xmlFail"
				End If
				 x=""
				Set xmlDoc = Nothing
				If WriteFlag Then
					Set fsOut = fso.OpenTextFile(MovieLibLog, ForAppending, True)
					fsOut.WriteLine MovieLogText
					fsOut.Close
					Set fsOut = Nothing
					thisfile.Copy (batchlogdir + thisfile.Name)
					thisfile.Move (aFiles(j,aFilesName) & "DONE")
				End If
				
			Else
				' Wscript.Echo "Dry Run - " & thisfile.Name & " batchnum=" & i & " not copied."
			End If
			Set thisfile = fso.GetFile(aFiles(j,aFilesMname))
			If Not dryrun Then
				If WriteFlag Then
					thisfile.Move (aFiles(j,aFilesMname) & "DONE")
					Wscript.Echo "DVD " & aBurn(i,aBurnDVDNum) & " " &  thisfile.Name & " batchnum=" & i
				End If
			Else
				' Wscript.Echo "Dry Run - " & thisfile.Name & " batchnum=" & i & " not moved."
			End If
		End If
	Next
	Wscript.Echo "============ DVD Number " & aBurn(i,aBurnDVDNum) & " Done ======= "
Next

' bye
Wscript.Echo "Completed Proccesing " & lastbatch & " batches"
'debug
If Not dryrun Then
	Wscript.Quit 0
End If

'main_end
' =======================
'Utility Code
'
Function RunCMD (ByVal cmd)                                                    
' Returns the exit code of the external program.                            
'Wscript.Echo "Start Run"
   Dim sh: Set sh = CreateObject("WScript.Shell")                           
   Dim wsx: Set wsx = Sh.Exec(cmd)                                          
   If wsx.ProcessID = 0 And wsx.Status = 1 Then                             
      ' (The Win98 version of VBScript does not detect WshShell.Exec errors)
      Err.Raise vbObjectError,,"WshShell.Exec failed."                      
Wscript.Echo "Run Failed"
      End If                                                                
   Do                                                                       
      Dim Status: Status = wsx.Status                                       
      WScript.StdOut.Write wsx.StdOut.ReadAll()                             
      WScript.StdErr.Write wsx.StdErr.ReadAll()                             
      If Status <> 0 Then Exit Do                                           
      WScript.Sleep 10                                                      
      Loop                                                                  
   RunCMD = wsx.ExitCode
'   Wscript.Echo "run =" & RunCMD
                                                       
End Function                                                             
 

'Work with INI files In VBS (ASP/WSH)
'v1.00
'2003 Antonin Foller, PSTRUH Software, http://www.motobit.com
'Function GetINIString(Section, KeyName, Default, FileName)
'Sub WriteINIString(Section, KeyName, Value, FileName)

Sub WriteINIString(Section, KeyName, Value, FileName)
  Dim INIContents, PosSection, PosEndSection
  
  'Get contents of the INI file As a string
  INIContents = GetFile(FileName)

  'Find section
  PosSection = InStr(1, INIContents, "[" & Section & "]", vbTextCompare)
  If PosSection>0 Then
    'Section exists. Find end of section
    PosEndSection = InStr(PosSection, INIContents, vbCrLf & "[")
    '?Is this last section?
    If PosEndSection = 0 Then PosEndSection = Len(INIContents)+1
    
    'Separate section contents
    Dim OldsContents, NewsContents, Line
    Dim sKeyName, Found
    OldsContents = Mid(INIContents, PosSection, PosEndSection - PosSection)
    OldsContents = split(OldsContents, vbCrLf)

    'Temp variable To find a Key
    sKeyName = LCase(KeyName & "=")

    'Enumerate section lines
    For Each Line In OldsContents
      If LCase(Left(Line, Len(sKeyName))) = sKeyName Then
        Line = KeyName & "=" & Value
        Found = True
      End If
      NewsContents = NewsContents & Line & vbCrLf
    Next

    If isempty(Found) Then
      'key Not found - add it at the end of section
      NewsContents = NewsContents & KeyName & "=" & Value
    Else
      'remove last vbCrLf - the vbCrLf is at PosEndSection
      NewsContents = Left(NewsContents, Len(NewsContents) - 2)
    End If

    'Combine pre-section, new section And post-section data.
    INIContents = Left(INIContents, PosSection-1) & _
      NewsContents & Mid(INIContents, PosEndSection)
  else'if PosSection>0 Then
    'Section Not found. Add section data at the end of file contents.
    If Right(INIContents, 2) <> vbCrLf And Len(INIContents)>0 Then 
      INIContents = INIContents & vbCrLf 
    End If
    INIContents = INIContents & "[" & Section & "]" & vbCrLf & _
      KeyName & "=" & Value
  end if'if PosSection>0 Then
  WriteFile FileName, INIContents
End Sub

Function GetINIString(Section, KeyName, Default, FileName)
  Dim INIContents, PosSection, PosEndSection, sContents, Value, Found
  
  'Get contents of the INI file As a string
  INIContents = GetFile(FileName)

  'Find section
  PosSection = InStr(1, INIContents, "[" & Section & "]", vbTextCompare)
  If PosSection>0 Then
    'Section exists. Find end of section
    PosEndSection = InStr(PosSection, INIContents, vbCrLf & "[")
    '?Is this last section?
    If PosEndSection = 0 Then PosEndSection = Len(INIContents)+1
    
    'Separate section contents
    sContents = Mid(INIContents, PosSection, PosEndSection - PosSection)

    If InStr(1, sContents, vbCrLf & KeyName & "=", vbTextCompare)>0 Then
      Found = True
      'Separate value of a key.
      Value = SeparateField(sContents, vbCrLf & KeyName & "=", vbCrLf)
    End If
  End If
  If isempty(Found) Then Value = Default
  GetINIString = Value
End Function

'Separates one field between sStart And sEnd
Function SeparateField(ByVal sFrom, ByVal sStart, ByVal sEnd)
  Dim PosB: PosB = InStr(1, sFrom, sStart, 1)
  If PosB > 0 Then
    PosB = PosB + Len(sStart)
    Dim PosE: PosE = InStr(PosB, sFrom, sEnd, 1)
    If PosE = 0 Then PosE = InStr(PosB, sFrom, vbCrLf, 1)
    If PosE = 0 Then PosE = Len(sFrom) + 1
    SeparateField = Mid(sFrom, PosB, PosE - PosB)
  End If
End Function


'File functions
Function GetFile(ByVal FileName)
  Dim FS: Set FS = CreateObject("Scripting.FileSystemObject")
  'Go To windows folder If full path Not specified.
  If InStr(FileName, ":\") = 0 And Left (FileName,2)<>"\\" Then 
    FileName = FS.GetSpecialFolder(0) & "\" & FileName
  End If
  On Error Resume Next

  GetFile = FS.OpenTextFile(FileName).ReadAll
End Function

Function WriteFile(ByVal FileName, ByVal Contents)
  
  Dim FS: Set FS = CreateObject("Scripting.FileSystemObject")
  'On Error Resume Next

  'Go To windows folder If full path Not specified.
  If InStr(FileName, ":\") = 0 And Left (FileName,2)<>"\\" Then 
    FileName = FS.GetSpecialFolder(0) & "\" & FileName
  End If

  Dim OutStream: Set OutStream = FS.OpenTextFile(FileName, 2, True)
  OutStream.Write Contents
End Function


''' Regular Array Sort

Sub QuickSort(vec,loBound,hiBound,SortField,SortDir)
  '==--------------------------------------------------------==
  '== Sort a multi dimensional array on SortField            ==
  '==                                                        ==
  '== This procedure is adapted from the algorithm given in: ==
  '==    ~ Data Abstractions & Structures using C++ by ~     ==
  '==    ~ Mark Headington and David Riley, pg. 586    ~     ==
  '== Quicksort is the fastest array sorting routine for     ==
  '== unordered arrays.  Its big O is n log n                ==
  '==                                                        ==
  '== Parameters:                                            ==
  '== vec       - array to be sorted                         ==
  '== SortField - The field to sort on (1st dimension value) ==
  '== loBound and hiBound are simply the upper and lower     ==
  '==   bounds of the array's "row" dimension. It's probably ==
  '==   easiest to use the LBound and UBound functions to    ==
  '==   set these.                                           ==
  '== SortDir   - ASC, ascending; DESC, Descending           ==
  '==--------------------------------------------------------==
  if not (hiBound - loBound = 0) then
      Dim pivot(),loSwap,hiSwap,temp,counter
      Redim pivot (Ubound(vec,2))
      SortDir = UCase(SortDir)

      '== Two items to sort
      if hiBound - loBound = 1 then
        if (SortDir = "ASC") then
            if FormatCompare(vec(loBound,SortField),vec(hiBound,SortField)) > FormatCompare(vec(hiBound,SortField),vec(loBound,SortField)) then Call SwapRows(vec,hiBound,loBound)
        else
            if FormatCompare(vec(loBound,SortField),vec(hiBound,SortField)) < FormatCompare(vec(hiBound,SortField),vec(loBound,SortField)) then Call SwapRows(vec,hiBound,loBound)
        end if
      End If

      '== Three or more items to sort
      For counter = 0 to Ubound(vec,2)
        pivot(counter) = vec(int((loBound + hiBound) / 2),counter)
        vec(int((loBound + hiBound) / 2),counter) = vec(loBound,counter)
        vec(loBound,counter) = pivot(counter)
      Next

      loSwap = loBound + 1
      hiSwap = hiBound

      do
        '== Find the right loSwap
        if (SortDir = "ASC") then
            while loSwap < hiSwap and FormatCompare(vec(loSwap,SortField),pivot(SortField)) <= FormatCompare(pivot(SortField),vec(loSwap,SortField))
              loSwap = loSwap + 1
            wend
        else
            while loSwap < hiSwap and FormatCompare(vec(loSwap,SortField),pivot(SortField)) >= FormatCompare(pivot(SortField),vec(loSwap,SortField))
              loSwap = loSwap + 1
            wend
        end if
        '== Find the right hiSwap
        if (SortDir = "ASC") then
            while FormatCompare(vec(hiSwap,SortField),pivot(SortField)) > FormatCompare(pivot(SortField),vec(hiSwap,SortField))
              hiSwap = hiSwap - 1
            wend
        else
            while FormatCompare(vec(hiSwap,SortField),pivot(SortField)) < FormatCompare(pivot(SortField),vec(hiSwap,SortField))
              hiSwap = hiSwap - 1
            wend
        end if
        '== Swap values if loSwap is less then hiSwap
        if loSwap < hiSwap then Call SwapRows(vec,loSwap,hiSwap)
      loop while loSwap < hiSwap

      For counter = 0 to Ubound(vec,2)
        vec(loBound,counter) = vec(hiSwap,counter)
        vec(hiSwap,counter) = pivot(counter)
      Next

      '== Recursively call function .. the beauty of Quicksort
        '== 2 or more items in first section
        if loBound < (hiSwap - 1) then Call QuickSort(vec,loBound,hiSwap-1,SortField,SortDir)
        '== 2 or more items in second section
        if hiSwap + 1 < hibound then Call QuickSort(vec,hiSwap+1,hiBound,SortField,SortDir)
  end if
End Sub  'QuickSort

Sub SwapRows(ary,row1,row2)
  '==------------------------------------------==
  '== This proc swaps two rows of an array     ==
  '==------------------------------------------==

  Dim x,tempvar
  For x = 0 to Ubound(ary,2)
    tempvar = ary(row1,x)
    ary(row1,x) = ary(row2,x)
    ary(row2,x) = tempvar
  Next
End Sub  'SwapRows

function FormatCompare(sOne,sTwo)
  '==------------------------------------------==
  '==  Checks sOne & sTwo, returns sOne as a   ==
  '==  Numeric if both pass isNumeric, if not  ==
  '==  returns sOne as a string.               ==
  '==------------------------------------------==

    if (isNumeric(Trim(sOne)) AND isNumeric(Trim(sTwo))) then
        FormatCompare = CDbl(Trim(sOne))
    else
        FormatCompare = Trim(sOne)
    end if
end function

Sub PrintArray(vec,loRow,hiRow,markCol)
  '==------------------------------------------==
  '== Print out an array  Highlight the column ==
  '==  whose number matches param markCol      ==
  '==------------------------------------------==

  Dim ColNmbr,RowNmbr
  Response.Write "<table border=""1"" cellspacing=""0"">"
  For RowNmbr = loRow to hiRow
    Response.Write "<tr>"
    For ColNmbr = 0 to (Ubound(vec,2) - 1)
      If ColNmbr = markCol then
        Response.Write "<td bgcolor=""FFFFCC"">"
      Else
        Response.Write "<td>"
      End If
      Response.Write vec(RowNmbr,ColNmbr) & "</td>"
    Next
    Response.Write "</tr>"
  Next
  Response.Write "</table>"
End Sub  'PrintArray
